(function () {
"use strict";
const XBCustomizeHelper = {
_appName: CB_APP_NAME,
get _barCore() {
delete this._barCore;
return this._barCore = Components.classes["@yandex.ru/custombarcore;" + this._appName].getService().wrappedJSObject;
}
,
get _application() {
delete this._application;
return this._application = this._barCore.application;
}
,
get _logger() {
delete this._logger;
return this._logger = this._application.getLogger("XBCustomizeHelper");
}
,
get _defaultWidgetsProtoIDs() {
var defaultWidgetsProtoIDs = Object.create(null);
this._application.defaultPreset.visibleWidgetEntries.forEach(function XBCHelper_makeDefaultWidgetsProtoIDs(aWidgetEntry) {
defaultWidgetsProtoIDs[aWidgetEntry.componentID] = true;
}
);
delete this._defaultWidgetsProtoIDs;
return this._defaultWidgetsProtoIDs = defaultWidgetsProtoIDs;
}
,
get _defaultWidgetEntriesLength() {
delete this._defaultWidgetEntriesLength;
return this._defaultWidgetEntriesLength = this._application.defaultPreset.visibleWidgetEntries.length;
}
,
_init: function XBCHelper__init() {
var me = this;
var origRestoreDefaultSet = window.restoreDefaultSet;
window.restoreDefaultSet = function XBCHelper_restoreDefaultSet() {
try {
me._onRestoreDefaultSet();
}
catch (e) {
me._logger.error("XBCHelper_restoreDefaultSet error: " + e);
}

return origRestoreDefaultSet.apply(window,arguments);
}
;
var palette = document.getElementById("palette-box");
palette.addEventListener("drop",this,true);
var prefsWindow = this._barCore.Lib.misc.getTopWindowOfType(this._appName + ":Preferences");
if (prefsWindow)
prefsWindow.document.documentElement.cancelDialog();
}
,
_destroy: function XBCHelper__destroy() {
var palette = document.getElementById("palette-box");
palette.removeEventListener("drop",this,true);
}
,
handleEvent: function XBCHelper_handleEvent(aEvent) {
if (aEvent.type == "drop")
this._onPaletteDrop(aEvent);
}
,
_onPaletteDrop: function XBCHelper__onPaletteDrop(aEvent) {
var documentId = gToolboxDocument.documentElement.id;
var itemId = aEvent.dataTransfer.getData("text/toolbarwrapper-id/" + documentId);
var wrapper = itemId && gToolboxDocument.getElementById("wrapper-" + itemId);
if (! wrapper)
return;
var item = wrapper.firstChild;
if (item.wdgtIsPlatformWidget && ! item.wdgtIsUnique && item.wdgtApplicationName == this._appName)
{
item.wdgtKill();
wrapper.parentNode.removeChild(wrapper);
}

}
,
_onRestoreDefaultSet: function XBCHelper__onRestoreDefaultSet() {
var items = gToolboxDocument.querySelectorAll("toolbaritem[cb-app='" + this._appName + "']");
for (let i = items.length;i--;) {
let item = items[i];
try {
if (item.wdgtIsPlatformWidget)
{
item.wdgtKill();
if (! item.wdgtIsUnique || item.wdgtPrototypeID in this._defaultWidgetsProtoIDs)
item.parentNode.parentNode.removeChild(item.parentNode);
}

}
catch (e) {
this._logger.error(e);
}

}

var toolbox = gToolboxDocument.getElementById("navigator-toolbox");
if (toolbox)
toolbox.removeAttribute("cb-barless");
this._barCore.application.widgetLibrary.setDefaultPluginsState();
}
};
var origGetCurrentItemIds = window.getCurrentItemIds;
window.getCurrentItemIds = function XBCHelper_getCurrentItemIds() {
var ids = origGetCurrentItemIds.apply(window,arguments);
var idPrefix = XBCustomizeHelper._appName + ".cb-default-";
var i = XBCustomizeHelper._defaultWidgetEntriesLength;
while (i--) ids[idPrefix + i] = 1;
["spring", "separator", "spacer"].forEach(function (widgetName) {
ids[XBCustomizeHelper._appName + ".cb-http://bar.yandex.ru/packages/yandexbar#" + widgetName + "-inst-0"] = 1;
}
);
return ids;
}
;
window.addEventListener("load",function onLoadListener(aLoadEvent) {
aLoadEvent.currentTarget.removeEventListener("load",onLoadListener,false);
aLoadEvent.currentTarget.addEventListener("unload",function onUnloadListener(aUnloadEvent) {
aUnloadEvent.currentTarget.removeEventListener("unload",onUnloadListener,false);
XBCustomizeHelper._destroy();
}
,false);
XBCustomizeHelper._init();
}
,false);
}
)();
