"use strict";
var EXPORTED_SYMBOLS = ["module"];
var nsScriptableUnicodeConverter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"];
var nsIScriptableUnicodeConverter = Components.interfaces.nsIScriptableUnicodeConverter;
var nsHash = Components.classes["@mozilla.org/security/hash;1"];
var nsICryptoHash = Components.interfaces.nsICryptoHash;
var commonUtils = {
};
commonUtils.generateRandomString = function (length) {
var code, result = Array(length);
for (var i = 0;i < length;++i) {
code = 48 + Math.floor(Math.random() * 62);
if (code > 57)
code += 7;
if (code > 90)
code += 6;
result[i] = String.fromCharCode(code);
}

return result.join("");
}
;
commonUtils.sanitizeURL = function (url) {
var empty = "", protocol = /.*?:\/\//, params = /\?.*$/, hash = /#.*$/;
return url.replace(protocol,empty).replace(params,empty).replace(hash,empty);
}
;
commonUtils.callbacksMatch = function (base, callback) {
return commonUtils.sanitizeURL(callback).indexOf(commonUtils.sanitizeURL(base)) == 0;
}
;
commonUtils.duplicate = function (x) {
return JSON.parse(JSON.stringify(x));
}
;
commonUtils.mix = function mix(a, b) {
var r = commonUtils.duplicate(a);
for(var i in b) {
if (! b.hasOwnProperty(i))
{
continue;
}

var data = b[i], mixin;
if (i in a)
{
switch (typeof data) {
case "object":
mixin = mix(a[i],data);
break;
default:
mixin = b[i];
}

r[i] = mixin;
}
 else
{
r[i] = data;
}

}

if (arguments.length > 2)
{
var argsArr = Array.prototype.slice.call(arguments,2);
argsArr.unshift(r);
r = mix.apply(this,argsArr);
}

return r;
}
;
commonUtils.obj2UrlParams = function (obj, encode) {
var value = "", keyText, res = [], noencode = encode === false, keys = [];
for(var key in obj) {
if (obj.hasOwnProperty(key))
{
keys.push(key);
}

}

keys.sort();
for (var key, i = 0, l = keys.length;i < l;++i) {
key = keys[i];
value = noencode ? obj[key] : commonUtils.encodeURIComponent(obj[key]);
keyText = noencode ? key : commonUtils.encodeURIComponent(key);
res.push(keyText + "=" + value);
}

return res.join("&");
}
;
commonUtils.obj2HeaderParams = function (obj) {
var res = [], key, value, d1 = "", d2 = ", ";
for(key in obj) {
if (! obj.hasOwnProperty(key))
continue;
value = commonUtils.encodeURIComponent(obj[key]);
res.push([commonUtils.encodeURIComponent(key), "=\"", value, "\""].join(d1));
}

return res.join(d2);
}
;
commonUtils.urlParams2Obj = function (urlParams, decode) {
var res = {
}, nodecode = decode === false;
if (! urlParams || urlParams.length == 0)
{
return res;
}

var params = urlParams.split("&");
for (var i = 0, l = params.length;i < l;++i) {
var kv = params[i].split("=");
var key = kv[0], value = kv[1];
key = nodecode ? key : commonUtils.decodeURIComponent(key);
res[key] = nodecode ? value : commonUtils.decodeURIComponent(value);
}

return res;
}
;
commonUtils.encodeURIComponent = function (str) {
return encodeURIComponent(str).replace(/[!'\(\)\*]/g,function (x) {
return "%" + ("0" + x.charCodeAt(0).toString(16)).slice(- 2).toUpperCase();
}
);
}
;
commonUtils.decodeURIComponent = function (str) {
str = str || "";
return decodeURIComponent(str.replace(/\+/g,"%20"));
}
;
commonUtils.digest = function (algo, str) {
function toHexString(charCode) {
return ("0" + charCode.toString(16)).slice(- 2);
}

var converter = nsScriptableUnicodeConverter.createInstance(nsIScriptableUnicodeConverter);
converter.charset = "UTF-8";
var t = {
};
var data = converter.convertToByteArray(str,t);
var ch = nsHash.createInstance(nsICryptoHash);
var init;
switch (algo) {
case "md5":
init = ch.MD5;
break;
case "sha1":
init = ch.SHA1;
break;
}

ch.init(init);
ch.update(data,data.length);
var hash = ch.finish(false);
var s = [];
for (var i = 0, l = hash.length;i < l;++i) {
s.push(toHexString(hash.charCodeAt(i)));
}

return s.join("");
}
;
commonUtils.getCookie = function (name, host) {
var cookieMgr = Components.classes["@mozilla.org/cookiemanager;1"].getService(Components.interfaces.nsICookieManager);
for (var e = cookieMgr.enumerator;e.hasMoreElements();) {
var cookie = e.getNext().QueryInterface(Components.interfaces.nsICookie);
if (cookie.name == name && cookie.host == host)
{
return cookie.value || "";
}

}

return "";
}
;
function module(proxy) {
return commonUtils;
}

